"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const unexpected_1 = tslib_1.__importDefault(require("unexpected"));
const src_1 = require("../src");
class ReadDuplicate extends src_1.Benchmark {
    async setup() {
        await this.client.write(this.example);
        await this.client.read(this.example);
    }
    async run() {
        const sameShape = this.example.partials[0];
        this.result = await this.client.read(sameShape);
    }
    async verify() {
        unexpected_1.default(this.result.data, 'to satisfy', this.example.response);
    }
}
ReadDuplicate.metadata = {
    title: `duplicate read (fully cached, same query shape)`,
};
exports.default = ReadDuplicate;
