"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const unexpected_1 = tslib_1.__importDefault(require("unexpected"));
const src_1 = require("../src");
class ReadDuplicate extends src_1.Benchmark {
    async setup() {
        await this.client.write(this.example);
        await this.client.read(this.example);
    }
    async run() {
        const halfQuery = this.example.partials[3];
        this.result = await this.client.read(halfQuery);
    }
    async verify() {
        const { response } = this.example.partials[3];
        unexpected_1.default(this.result.data, 'to satisfy', response);
    }
}
ReadDuplicate.metadata = {
    title: `read 50% of fields (fully cached)`,
};
exports.default = ReadDuplicate;
