"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const unexpected_1 = tslib_1.__importDefault(require("unexpected"));
const src_1 = require("../src");
class WriteWithCompleteCache extends src_1.Benchmark {
    async setup() {
        await this.client.write(this.example);
    }
    async run() {
        await this.client.write(this.example);
    }
    async verify() {
        const { data } = await this.client.read(this.example);
        unexpected_1.default(data, 'to satisfy', this.example.response);
    }
}
WriteWithCompleteCache.metadata = {
    title: `repeated write (fully cached, identical query)`,
};
exports.default = WriteWithCompleteCache;
