"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const unexpected_1 = tslib_1.__importDefault(require("unexpected"));
const src_1 = require("../src");
class WriteWithOneObserverAndCompleteCache extends src_1.Benchmark {
    async setup() {
        await this.client.write(this.example);
        this.observer = this.client.observe(this.example);
    }
    async run() {
        await this.client.write(this.example);
    }
    async verify() {
        unexpected_1.default(this.observer.mostRecentResult().data, 'to satisfy', this.example.response);
    }
    async teardown() {
        this.observer.unsubscribe();
    }
}
WriteWithOneObserverAndCompleteCache.metadata = {
    title: `write (1 observer, fully cached, identical query written)`,
};
exports.default = WriteWithOneObserverAndCompleteCache;
