"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const unexpected_1 = tslib_1.__importDefault(require("unexpected"));
const src_1 = require("../src");
class WriteWithTenObserversAndCompleteCache extends src_1.Benchmark {
    constructor() {
        super(...arguments);
        this.observers = [];
    }
    async setup() {
        await this.client.write(this.example);
        for (let i = 0; i < 8; i++) {
            this.observers.push(this.client.observe(this.example));
        }
    }
    async run() {
        await this.client.write(this.example);
    }
    async verify() {
        for (const observer of this.observers) {
            unexpected_1.default(observer.mostRecentResult().data, 'to satisfy', this.example.response);
        }
    }
    async teardown() {
        for (const observer of this.observers) {
            observer.unsubscribe();
        }
    }
}
WriteWithTenObserversAndCompleteCache.metadata = {
    title: `write (8 identical observers, fully cached, identical query written)`,
};
exports.default = WriteWithTenObserversAndCompleteCache;
