"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const unexpected_1 = tslib_1.__importDefault(require("unexpected"));
const src_1 = require("../src");
class WriteWithTenObserversAndEmptyCache extends src_1.Benchmark {
    constructor() {
        super(...arguments);
        this.observers = [];
    }
    async setup() {
        await this.client.write(this.example);
        for (let i = 0; i < 8; i++) {
            this.observers.push(this.client.observe(this.example.partials[i]));
        }
    }
    async run() {
        await this.client.write(this.example);
    }
    async verify() {
        for (let i = 0; i < 8; i++) {
            const observer = this.observers[i];
            const { response } = this.example.partials[i];
            unexpected_1.default(observer.mostRecentResult().data, 'to satisfy', response);
        }
    }
    async teardown() {
        for (const observer of this.observers) {
            observer.unsubscribe();
        }
    }
}
WriteWithTenObserversAndEmptyCache.metadata = {
    title: `write (8 observers, fully cached)`,
};
exports.default = WriteWithTenObserversAndEmptyCache;
