"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ink_1 = require("ink");
const SuiteSummary_1 = require("./SuiteSummary");
const reporting_1 = require("../../reporting");
// Update at a lowish framerate to give priority to benchmarks.
const UPDATE_DELAY_MS = 50;
class Root extends ink_1.Component {
    constructor() {
        super(...arguments);
        this._collector = new reporting_1.SuiteSummaryCollector(summary => {
            this._summary = summary;
            if (this._updateTimer)
                return;
            this._updateTimer = setTimeout(() => this.forceUpdate(), UPDATE_DELAY_MS);
        }, () => {
            this.forceUpdate();
        });
    }
    componentDidMount() {
        this.props.registerEventHandler(this._collector.consumeEvent);
    }
    render() {
        if (this._updateTimer) {
            clearTimeout(this._updateTimer);
            this._updateTimer = null;
        }
        if (!this._summary)
            return '';
        return React.createElement(SuiteSummary_1.SuiteSummary, Object.assign({}, this._summary));
    }
    componentWillUnmount() {
        this.props.onExit();
    }
}
exports.Root = Root;
