"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const ink_1 = require("ink");
const le_table_1 = tslib_1.__importDefault(require("le-table"));
class Table extends ink_1.Component {
    constructor() {
        super(...arguments);
        this._renderCell = (cell) => {
            const _a = cell.props, { children } = _a, options = tslib_1.__rest(_a, ["children"]);
            return {
                text: ink_1.renderToString(React.createElement("span", null, children)),
                data: options,
            };
        };
    }
    render() {
        const _a = this.props, { children } = _a, options = tslib_1.__rest(_a, ["children"]);
        const table = new le_table_1.default(options);
        for (const row of toArray(children)) {
            const cells = toArray(row.props.children).map(this._renderCell);
            table.addRow(cells);
        }
        return table.stringify();
    }
}
exports.Table = Table;
(function (Table) {
    class Row extends ink_1.Component {
    }
    Table.Row = Row;
    class Cell extends ink_1.Component {
        render() {
            return React.createElement("span", null, this.props.children);
        }
    }
    Table.Cell = Cell;
})(Table = exports.Table || (exports.Table = {}));
function toArray(value) {
    return Array.isArray(value) ? value : [value];
}
