"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const path = tslib_1.__importStar(require("path"));
const webpack = tslib_1.__importStar(require("webpack"));
const html_webpack_plugin_1 = tslib_1.__importDefault(require("html-webpack-plugin"));
const webpack_visualizer_plugin_1 = tslib_1.__importDefault(require("webpack-visualizer-plugin"));
// Assert that we export values that conform to Webpack's configuration.
function assertValidConfiguration(config) { }
assertValidConfiguration(exports);
// https://webpack.js.org/concepts/mode/
exports.mode = 'production';
// https://webpack.js.org/configuration/entry-context/#context
exports.context = path.resolve(__dirname, '..', '..', '..');
// https://webpack.js.org/configuration/entry-context/#entry
exports.entry = './src/reporters/web/entry';
// https://webpack.js.org/configuration/resolve/
exports.resolve = {
    // https://webpack.js.org/configuration/resolve/#resolve-extensions
    extensions: ['.ts', '.tsx', '.js'],
};
// https://webpack.js.org/configuration/module/
exports.module = {
    // https://webpack.js.org/configuration/module/#module-rules
    rules: [
        // https://github.com/TypeStrong/ts-loader#configuration
        { test: /\.tsx?$/, loader: 'ts-loader' },
        // https://github.com/webpack-contrib/raw-loader#getting-started
        { test: /\.gql$/, loader: 'raw-loader' },
        // https://github.com/graphql/graphql-js/issues/1272
        {
            test: /\.mjs$/,
            include: /node_modules/,
            type: 'javascript/auto',
        },
    ],
};
exports.plugins = [
    // https://github.com/jantimon/html-webpack-plugin#options
    new html_webpack_plugin_1.default({
        title: `GraphQL Client Benchmarks`,
    }),
    // https://github.com/chrisbateman/webpack-visualizer#plugin-usage
    new webpack_visualizer_plugin_1.default(),
    // Ignore Node-side polyfills that we depend upon.
    new webpack.IgnorePlugin(/(^|\/)(fs|require-context)(\/|$)/),
    // relay-compiler and its transitive dependencies expect a Node environment,
    // but we are careful to avoid Node-dependent functionality.
    new webpack.IgnorePlugin(/(^|\/)(child_process|fs|fb-watchman)(\/|$)/),
    // Similarly, make sure that webpack doesn't suck in our other reporters.
    new webpack.IgnorePlugin(/src\/reporters\/(?!web)[^/]+(\/|$)/),
];
// https://webpack.js.org/configuration/externals/
exports.externals = {};
